---
title: llarp::RoutePoker

---

# llarp::RoutePoker





Inherits from std::enable_shared_from_this< RoutePoker >

## Public Functions

|                | Name           |
| -------------- | -------------- |
| void | **[AddRoute](Classes/structllarp_1_1RoutePoker.md#function-addroute)**(net::ipv4addr_t ip)<br>add a route exception to an edge by ip if we have a default gateway and our routes are set to be "up" we will enable this route.  |
| void | **[DelRoute](Classes/structllarp_1_1RoutePoker.md#function-delroute)**(net::ipv4addr_t ip)<br>remove a route exception to an edge by ip.  |
| void | **[Start](Classes/structllarp_1_1RoutePoker.md#function-start)**([AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) * router) |
| | **[~RoutePoker](Classes/structllarp_1_1RoutePoker.md#function-~routepoker)**() |
| void | **[Up](Classes/structllarp_1_1RoutePoker.md#function-up)**()<br>explicitly put routes up  |
| void | **[Down](Classes/structllarp_1_1RoutePoker.md#function-down)**()<br>explicitly put routes down  |
| void | **[SetDNSMode](Classes/structllarp_1_1RoutePoker.md#function-setdnsmode)**(bool using_exit_mode) const<br>set dns resolver pass in if we are using exit node mode right now as a bool  |

## Public Functions Documentation

### function AddRoute

```cpp
void AddRoute(
    net::ipv4addr_t ip
)
```

add a route exception to an edge by ip if we have a default gateway and our routes are set to be "up" we will enable this route. 

if there is an existing entry for this ip, we increment a reference counter and keep the route previously added in. 


### function DelRoute

```cpp
void DelRoute(
    net::ipv4addr_t ip
)
```

remove a route exception to an edge by ip. 

decrements the number of edges that use this ip. when the reference counter hits zero and we are "up" we unmap the route. 


### function Start

```cpp
void Start(
    AbstractRouter * router
)
```


### function ~RoutePoker

```cpp
~RoutePoker()
```


### function Up

```cpp
void Up()
```

explicitly put routes up 

### function Down

```cpp
void Down()
```

explicitly put routes down 

### function SetDNSMode

```cpp
void SetDNSMode(
    bool using_exit_mode
) const
```

set dns resolver pass in if we are using exit node mode right now as a bool 

-------------------------------

Updated on 2023-05-23 at 16:33:42 +0000